searchNodes=[{"doc":"Parse and validate your environment variables easily in Elixir with the following benefits. Compile time access guarantees Parsed values with accurate elixir data types Validation of required values before app boot mix environment specific defaults and fallbacks Read more for understanding why to use this package and its benefits. The complete documentation for mahaul is available online at HexDocs . Requirements Elixir 1.13+ Installation Add mahaul to your list of dependencies in mix.exs : def deps do [ { :mahaul , &quot;~&gt; 0.3.0&quot; } ] end Run mix deps.get Add config in your config/config.exs file config :mahaul , mix_env : Mix . env ( ) Getting started Define the environment variables needed in your app defmodule MyApp.Env do use Mahaul , PORT : [ type : :port , default_dev : &quot;4000&quot; ] , DEPLOYMENT_ENV : [ type : :enum , choices : [ :dev , :staging , :live ] , default_dev : &quot;dev&quot; ] , DATABASE_URL : [ type : :uri , default_dev : &quot;postgresql://user:pass@localhost:5432/app_dev&quot; ] , ANOTHER_ENV : [ type : :host , default : &quot;//localhost&quot; ] end Use in config/runtime.exs import Config if config_env ( ) == :dev do MyApp.Env . validate ( ) config :my_app , MyApp.Endpoint , http : [ port : MyApp.Env . port ( ) ] end if config_env ( ) == :prod do MyApp.Env . validate! ( ) config :my_app , MyApp.Repo , url : MyApp.Env . database_url ( ) config :my_app , :something , another : MyApp.Env . another_env ( ) if MyApp.Env . deployment_env ( ) == :staging do # configure something more end end Use anywhere in the code defmodule MyApp.Magic def do_magic ( env \\\\ MyApp.Env . deployment_env ( ) ) def do_magic ( :live ) , do : &quot;Magic on live&quot; def do_magic ( :staging ) , do : &quot;Magic on staging&quot; def do_magic ( :dev ) , do : &quot;Magic on dev&quot; end Supported types The following type configurations are supported. Type Elixir Type Valid Environment variables value :str String Any string :enum Atom Any string :num Float Any string that can be parsed as float :int Integer Any string that can be parsed as integer :bool Boolean &quot;true&quot; and &quot;1&quot; as true ; &quot;false&quot; and &quot;0&quot; as false :port Integer Any valid port value between &quot;1&quot; to &quot;65535&quot; (casted as integer) :host String Any valid host name :uri String Any valid uris Setting Defaults Any defaults and fallback values can be set globally using the default or for development environment using the default_dev configuration options. Make sure to use the string values same as we set in the actual system environment, as it will be parsed depending upon the provided type configuration. Globally defmodule MyApp.Env do use Mahaul , MY_ENV : [ type : :str , default : &quot;Hello World&quot; ] end iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello World MY_ENV = &quot;Hello Universe&quot; iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Universe For dev/test environment defmodule MyApp.Env do use Mahaul , MY_ENV : [ type : :str , dev_default : &quot;Hello Dev&quot; ] end MIX_ENV = dev iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Dev MIX_ENV = dev MY_ENV = &quot;Hello World&quot; iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello World Globally with dev/test environment overrides defmodule MyApp.Env do use Mahaul , MY_ENV : [ type : :str , default : &quot;Hello World&quot; , dev_default : &quot;Hello Dev&quot; ] end MIX_ENV = dev iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Dev MIX_ENV = dev MY_ENV = &quot;Hello Universe&quot; iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Universe MIX_ENV = prod iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello World MIX_ENV = prod MY_ENV = &quot;Hello Universe&quot; iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Universe Setting choices list You can further restrict the parsed values to a predefined list by setting the choices option with list of allowed values. Note that the values are parsed first and then matched against the provided list. defmodule MyApp.Env do use Mahaul , DEPLOYMENT_ENV : [ type : :enum , choices : [ :dev , :staging , :live ] ] , DAY_OF_WEEK : [ type : :int , choices : [ 1 , 2 , 3 , 4 , 5 , 6 , 7 ] ] end Why this package mahaul accomplishes the following functionalities for streamlining the environment variables requirements for an elixir app. Compile time access guarantees Using the meta programming capabilities of Elixir, mahaul creates compile time methods for accessing the environment variables. This guarantees that there are no accidental typos during the access of the environment variables from the code. Parsed values with accurate data types Depending upon the configuration, the access to the predefined environment variables string values are parsed and the correct elixir data types are returned. mahaul supports a wide range of commonly set environment variable types. It also supports the choices options to limit the allowed values for an environment variable. Validation of required values before app boot Often times we release new versions of the app accessing new environment variables, but we forget to set those for one of our app deployments. This creates nasty bugs that are only discovered when certain parts of the app behaves erratically or fails. With mahaul , you can pre-validate the existence of the required environment variables with correct values before booting the app (ideally in config/runtime.exs ). This ensures that your application will fail to boot unless you have set those environment variables with correct values. This works really well with any cloud deployments that makes new version of your app active and available only after ensuring the new deployment had a successful boot. Defaults and fallbacks You can set default values for the production or development environment of your app while configuring mahaul . This comes handy when you want some defaults for dev/test environment to let other contributors of your app quickly start the dev environment of your app without worrying to set some needed environment variables. Or have some sensible defaults for production version of your app with flexibility to change the values by setting an environment variable. Contributing Contributions are welcome Running tests Clone the repo and fetch its dependencies: git clone https://github.com/emadalam/mahaul.git cd mahaul mix deps.get mix test Building docs MIX_ENV=docs mix docs LICENSE See LICENSE","ref":"Mahaul.html","title":"Mahaul","type":"module"},{"doc":"Basic helpers for parsing and validating the system environment variables.","ref":"Mahaul.Helpers.html","title":"Mahaul.Helpers","type":"module"},{"doc":"","ref":"Mahaul.Helpers.html#get_env/2","title":"Mahaul.Helpers.get_env/2","type":"function"},{"doc":"","ref":"Mahaul.Helpers.html#get_normalized_val/1","title":"Mahaul.Helpers.get_normalized_val/1","type":"function"},{"doc":":str iex&gt; Mahaul.Helpers . parse ( &quot;some value&quot; , :str ) { :ok , &quot;some value&quot; } :num iex&gt; Mahaul.Helpers . parse ( &quot;10&quot; , :num ) { :ok , 10.0 } iex&gt; Mahaul.Helpers . parse ( &quot;10.2345&quot; , :num ) { :ok , 10.2345 } iex&gt; Mahaul.Helpers . parse ( &quot;some value&quot; , :num ) { :error , nil } :int iex&gt; Mahaul.Helpers . parse ( &quot;10&quot; , :int ) { :ok , 10 } iex&gt; Mahaul.Helpers . parse ( &quot;10.2345&quot; , :int ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;some value&quot; , :int ) { :error , nil } :bool iex&gt; Mahaul.Helpers . parse ( true , :bool ) { :ok , true } iex&gt; Mahaul.Helpers . parse ( false , :bool ) { :ok , false } iex&gt; Mahaul.Helpers . parse ( &quot;true&quot; , :bool ) { :ok , true } iex&gt; Mahaul.Helpers . parse ( &quot;false&quot; , :bool ) { :ok , false } iex&gt; Mahaul.Helpers . parse ( &quot;1&quot; , :bool ) { :ok , true } iex&gt; Mahaul.Helpers . parse ( &quot;0&quot; , :bool ) { :ok , false } :port iex&gt; Mahaul.Helpers . parse ( &quot;1&quot; , :port ) { :ok , 1 } iex&gt; Mahaul.Helpers . parse ( &quot;65535&quot; , :port ) { :ok , 65535 } iex&gt; Mahaul.Helpers . parse ( &quot;8080&quot; , :port ) { :ok , 8080 } iex&gt; Mahaul.Helpers . parse ( &quot;some value&quot; , :port ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;-1&quot; , :port ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;0&quot; , :port ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;65536&quot; , :port ) { :error , nil } :host iex&gt; Mahaul.Helpers . parse ( &quot;//localhost&quot; , :host ) { :ok , &quot;//localhost&quot; } iex&gt; Mahaul.Helpers . parse ( &quot;//domain.com&quot; , :host ) { :ok , &quot;//domain.com&quot; } iex&gt; Mahaul.Helpers . parse ( &quot;//192.168.0.1&quot; , :host ) { :ok , &quot;//192.168.0.1&quot; } iex&gt; Mahaul.Helpers . parse ( &quot;ftp://localhost&quot; , :host ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;https://domain.com&quot; , :host ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;https&quot; , :host ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;https://domain.com/something&quot; , :host ) { :error , nil } :uri iex&gt; Mahaul.Helpers . parse ( &quot;ftp://localhost&quot; , :uri ) { :ok , &quot;ftp://localhost&quot; } iex&gt; Mahaul.Helpers . parse ( &quot;https://domain.com&quot; , :uri ) { :ok , &quot;https://domain.com&quot; } iex&gt; Mahaul.Helpers . parse ( &quot;postgresql://user:pass@localhost:5432/dev_db&quot; , :uri ) { :ok , &quot;postgresql://user:pass@localhost:5432/dev_db&quot; } iex&gt; Mahaul.Helpers . parse ( &quot;//localhost&quot; , :uri ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;//domain.com&quot; , :uri ) { :error , nil } iex&gt; Mahaul.Helpers . parse ( &quot;//192.168.0.1&quot; , :uri ) { :error , nil }","ref":"Mahaul.Helpers.html#parse/2","title":"Mahaul.Helpers.parse/2","type":"function"},{"doc":"","ref":"Mahaul.Helpers.html#parse_all/1","title":"Mahaul.Helpers.parse_all/1","type":"function"},{"doc":"","ref":"Mahaul.Helpers.html#validate/1","title":"Mahaul.Helpers.validate/1","type":"function"},{"doc":"","ref":"Mahaul.Helpers.html#validate!/1","title":"Mahaul.Helpers.validate!/1","type":"function"},{"doc":"","ref":"Mahaul.Helpers.html#validate_opts!/1","title":"Mahaul.Helpers.validate_opts!/1","type":"function"},{"doc":"","ref":"Mahaul.Helpers.html#t:config_type/0","title":"Mahaul.Helpers.config_type/0","type":"type"},{"doc":"","ref":"Mahaul.Helpers.html#t:error_type/0","title":"Mahaul.Helpers.error_type/0","type":"type"},{"doc":"","ref":"Mahaul.Helpers.html#t:parsed_vars_type/0","title":"Mahaul.Helpers.parsed_vars_type/0","type":"type"},{"doc":"","ref":"Mahaul.Helpers.html#t:success_type/0","title":"Mahaul.Helpers.success_type/0","type":"type"},{"doc":"","ref":"Mahaul.Helpers.html#t:var_type/0","title":"Mahaul.Helpers.var_type/0","type":"type"}]